# Summary

[rkyv](./rkyv.md)

# Foundations

- [Motivation](./motivation.md)
- [Zero-copy deserialization](./zero-copy-deserialization.md)
- [Architecture](./architecture.md)
  - [Relative pointers](./architecture/relative-pointers.md)
  - [Archive](./architecture/archive.md)
  - [Serialize](./architecture/serialize.md)
  - [Deserialize](./architecture/deserialize.md)
  - [Alignment](./architecture/alignment.md)
- [Format](./format.md)
- [Wrapper types](./wrapper-types.md)
- [Shared pointers](./shared-pointers.md)
- [Unsized types](./unsized-types.md)
- [Trait objects](./trait-objects.md)
- [Validation](./validation.md)
- [Feature comparison](./feature-comparison.md)
- [FAQ](./faq.md)

# Advanced rkyv

- [Validation]()
- [Serializer composition]()
- [Alternative writers]()
- [Extending serialization]()
- [Hybrid deserialization]()
- [Effective wrapper types]()
- [Archived vs unarchived types]()
  - [Impl duplication]()
- [Streaming serialization]()
- [Schema evolution]()
- [Nightly features]()
  - [Copy optimization]()
- [Derive macro features]()

[Contributors](./contributors.md)
